diff --git a/src/preprocessors/portscan.c b/src/preprocessors/portscan.c
index ad46d2a..98dc326 100644
--- a/src/preprocessors/portscan.c
+++ b/src/preprocessors/portscan.c
@@ -53,7 +53,7 @@
 **
 **  The primary goal of this portscan detection engine is to catch nmap and
 **  variant scanners.  The engine tracks connection attempts on TCP, UDP,
-**  ICMP, and IP Protocols.  If there is a valid response, the connection
+**  ICMP, SCTP, and IP Protocols.  If there is a valid response, the connection
 **  is marked as valid.  If there is no response or a invalid response
 **  (TCP RST), then we track these attempts separately, so we know the
 **  number of invalid responses and the number of connection attempts that
@@ -189,6 +189,24 @@ static PS_ALERT_CONF g_udp_hi_sweep =     {30,3,3,10};
 static PS_ALERT_CONF g_udp_hi_dist_ps =   {200,3,200,10};
 
 /*
+**  SCTP alert configurations
+*/
+static PS_ALERT_CONF g_sctp_low_ps =       {0,5,25,5};
+static PS_ALERT_CONF g_sctp_low_decoy_ps = {0,15,50,30};
+static PS_ALERT_CONF g_sctp_low_sweep =    {0,5,5,15};
+static PS_ALERT_CONF g_sctp_low_dist_ps =  {0,15,50,15};
+
+static PS_ALERT_CONF g_sctp_med_ps =       {200,10,60,15};
+static PS_ALERT_CONF g_sctp_med_decoy_ps = {200,30,120,60};
+static PS_ALERT_CONF g_sctp_med_sweep =    {30,5,5,20};
+static PS_ALERT_CONF g_sctp_med_dist_ps =  {200,30,120,30};
+
+static PS_ALERT_CONF g_sctp_hi_ps =        {200,3,100,10};
+static PS_ALERT_CONF g_sctp_hi_decoy_ps =  {200,7,200,60};
+static PS_ALERT_CONF g_sctp_hi_sweep =     {30,3,3,10};
+static PS_ALERT_CONF g_sctp_hi_dist_ps =   {200,3,200,10};
+
+/*
 **  IP Protocol alert configurations
 */
 static PS_ALERT_CONF g_ip_low_ps =        {0,10,10,50};
@@ -438,6 +456,11 @@ static int ps_filter_ignore(PS_PKT *ps_pkt)
             return 1;
         }
     }
+    else if(p->sctph)
+    {
+        if(!(portscan_eval_config->detect_scans & PS_PROTO_SCTP))
+            return 1;
+    }
     else
     {
         if(!(portscan_eval_config->detect_scans & PS_PROTO_IP))
@@ -455,7 +478,7 @@ static int ps_filter_ignore(PS_PKT *ps_pkt)
     {
         reverse_pkt = 1;
     }
-    else if (p->udph && p->ssnptr &&
+    else if ((p->udph || p->sctph) && p->ssnptr &&
              stream_api && stream_api->version >= STREAM_API_VERSION5)
     {
         if (stream_api->get_packet_direction(p) & PKT_FROM_SERVER)
@@ -644,6 +667,17 @@ static int ps_get_proto(PS_PKT *ps_pkt, int *proto)
         }
     }
 
+    if (portscan_eval_config->detect_scans & PS_PROTO_SCTP)
+    {
+        if ((p->sctph != NULL) ||
+            ((p->icmph != NULL) && (p->icmph->type == ICMP_DEST_UNREACH) &&
+             (p->icmph->code == ICMP_PORT_UNREACH) && (p->orig_sctph != NULL)))
+        {
+            *proto = PS_PROTO_SCTP;
+            return 0;
+        }
+    }
+
     if (portscan_eval_config->detect_scans & PS_PROTO_IP)
     {
         if ((IPH_IS_VALID(p) && (p->icmph == NULL))
@@ -1148,6 +1182,95 @@ static int ps_tracker_update_udp(PS_PKT *ps_pkt, PS_TRACKER *scanner,
     return 0;
 }
 
+static int ps_tracker_update_sctp(PS_PKT *ps_pkt, PS_TRACKER *scanner,
+                                  PS_TRACKER *scanned)
+{
+    Packet  *p;
+    time_t  pkt_time;
+    snort_ip    cleared;
+    IP_CLEAR(cleared);
+
+    p = (Packet *)ps_pkt->pkt;
+    pkt_time = packet_timeofday();
+
+    if(p->icmph)
+    {
+        if(p->icmph->type == ICMP_DEST_UNREACH &&
+           p->icmph->code == ICMP_PORT_UNREACH)
+        {
+            if(scanned)
+            {
+                ps_proto_update(&scanned->proto,0,1,CLEARED,0,0);
+                scanned->priority_node = 1;
+            }
+
+            if(scanner)
+            {
+                ps_proto_update(&scanner->proto,0,1,CLEARED,0,0);
+                scanner->priority_node = 1;
+            }
+        }
+    }
+    else if(p->sctph)
+    {
+        if (stream_api && (stream_api->version >= STREAM_API_VERSION5) &&
+            p->ssnptr)
+        {
+            uint32_t direction = stream_api->get_packet_direction(p);
+
+#ifdef SUP_IP6
+            if (direction == PKT_FROM_CLIENT)
+            {
+                if(scanned)
+                {
+                    ps_proto_update(&scanned->proto,1,0,
+                                     GET_SRC_IP(p),p->dp, pkt_time);
+                }
+
+                if(scanner)
+                {
+                    ps_proto_update(&scanner->proto,1,0,
+                                     GET_DST_IP(p),p->dp, pkt_time);
+                }
+            }
+            else if (direction == PKT_FROM_SERVER)
+            {
+                if(scanned)
+                    ps_proto_update(&scanned->proto,-1,0,CLEARED,0,0);
+
+                if(scanner)
+                    ps_proto_update(&scanner->proto,-1,0,CLEARED,0,0);
+            }
+#else
+            if (direction == PKT_FROM_CLIENT)
+            {
+                if(scanned)
+                {
+                    ps_proto_update(&scanned->proto,1,0,
+                                     p->iph->ip_src.s_addr,p->dp, pkt_time);
+                }
+
+                if(scanner)
+                {
+                    ps_proto_update(&scanner->proto,1,0,
+                                     p->iph->ip_dst.s_addr,p->dp, pkt_time);
+                }
+            }
+            else if (direction == PKT_FROM_SERVER)
+            {
+                if(scanned)
+                    ps_proto_update(&scanned->proto,-1,0,0,0,0);
+
+                if(scanner)
+                    ps_proto_update(&scanner->proto,-1,0,0,0,0);
+            }
+#endif
+        }
+    }
+
+    return 0;
+}
+
 static int ps_tracker_update_icmp(PS_PKT *ps_pkt, PS_TRACKER *scanner,
                                   PS_TRACKER *scanned)
 {
@@ -1240,6 +1363,12 @@ static int ps_tracker_update(PS_PKT *ps_pkt, PS_TRACKER *scanner,
 
             break;
 
+        case PS_PROTO_SCTP:
+            if(ps_tracker_update_sctp(ps_pkt, scanner, scanned))
+                return -1;
+
+            break;
+
         case PS_PROTO_IP:
             if(ps_tracker_update_ip(ps_pkt, scanner, scanned))
                 return -1;
@@ -1624,6 +1753,77 @@ static int ps_alert_udp(PS_PROTO *scanner, PS_PROTO *scanned)
     return 0;
 }
 
+static int ps_alert_sctp(PS_PROTO *scanner, PS_PROTO *scanned)
+{
+    static PS_ALERT_CONF *one_to_one;
+    static PS_ALERT_CONF *one_to_one_decoy;
+    static PS_ALERT_CONF *one_to_many;
+    static PS_ALERT_CONF *many_to_one;
+
+    /*
+    ** Set the configurations depending on the sensitivity
+    ** level.
+    */
+    switch(portscan_eval_config->sense_level)
+    {
+        case PS_SENSE_HIGH:
+            one_to_one       = &g_sctp_hi_ps;
+            one_to_one_decoy = &g_sctp_hi_decoy_ps;
+            one_to_many      = &g_sctp_hi_sweep;
+            many_to_one      = &g_sctp_hi_dist_ps;
+
+            break;
+
+        case PS_SENSE_MEDIUM:
+            one_to_one       = &g_sctp_med_ps;
+            one_to_one_decoy = &g_sctp_med_decoy_ps;
+            one_to_many      = &g_sctp_med_sweep;
+            many_to_one      = &g_sctp_med_dist_ps;
+
+            break;
+
+        case PS_SENSE_LOW:
+            one_to_one       = &g_sctp_low_ps;
+            one_to_one_decoy = &g_sctp_low_decoy_ps;
+            one_to_many      = &g_sctp_low_sweep;
+            many_to_one      = &g_sctp_low_dist_ps;
+
+            break;
+
+        default:
+            return -1;
+    }
+
+    /*
+    **  Do detection on the different portscan types.
+    */
+    if((portscan_eval_config->detect_scan_type & PS_TYPE_PORTSCAN) &&
+        ps_alert_one_to_one(scanner, scanned, one_to_one))
+    {
+        return 0;
+    }
+
+    if((portscan_eval_config->detect_scan_type & PS_TYPE_DECOYSCAN) &&
+        ps_alert_one_to_one_decoy(scanner, scanned, one_to_one_decoy))
+    {
+        return 0;
+    }
+
+    if((portscan_eval_config->detect_scan_type & PS_TYPE_PORTSWEEP) &&
+        ps_alert_one_to_many(scanner, scanned, one_to_many))
+    {
+        return 0;
+    }
+
+    if((portscan_eval_config->detect_scan_type & PS_TYPE_DISTPORTSCAN) &&
+        ps_alert_many_to_one(scanner, scanned, many_to_one))
+    {
+        return 0;
+    }
+
+    return 0;
+}
+
 static int ps_alert_icmp(PS_PROTO *scanner, PS_PROTO *scanned)
 {
     static PS_ALERT_CONF *one_to_many;
@@ -1702,6 +1902,11 @@ static int ps_tracker_alert(PS_PKT *ps_pkt, PS_TRACKER *scanner,
                           (scanned ? &scanned->proto : NULL));
             break;
 
+        case PS_PROTO_SCTP:
+            ps_alert_sctp((scanner ? &scanner->proto : NULL),
+                          (scanned ? &scanned->proto : NULL));
+            break;
+
         case PS_PROTO_IP:
             ps_alert_ip((scanner ? &scanner->proto : NULL),
                         (scanned ? &scanned->proto : NULL));
@@ -1823,6 +2028,12 @@ void ps_tracker_print(PS_TRACKER* ps_tracker)
         ps_proto_print(&ps_tracker->proto);
         proto_index++;
     }
+    if(portscan_eval_config->detect_scans & PS_PROTO_SCTP)
+    {
+        printf("    ** SCTP **\n");
+        ps_proto_print(&ps_tracker->proto);
+        proto_index++;
+    }
     if(portscan_eval_config->detect_scans & PS_PROTO_IP)
     {
         printf("    ** IP **\n");
diff --git a/src/preprocessors/portscan.h b/src/preprocessors/portscan.h
index 1f32e98..07bebce 100644
--- a/src/preprocessors/portscan.h
+++ b/src/preprocessors/portscan.h
@@ -103,9 +103,10 @@ typedef struct s_PS_PKT
 #define PS_PROTO_NONE        0x00
 #define PS_PROTO_TCP         0x01
 #define PS_PROTO_UDP         0x02
-#define PS_PROTO_ICMP        0x04
-#define PS_PROTO_IP          0x08
-#define PS_PROTO_ALL         0x0f
+#define PS_PROTO_SCTP        0x04
+#define PS_PROTO_ICMP        0x08
+#define PS_PROTO_IP          0x10
+#define PS_PROTO_ALL         0x1f
 
 #define PS_PROTO_OPEN_PORT   0x80
 
diff --git a/src/preprocessors/spp_frag3.c b/src/preprocessors/spp_frag3.c
index 0d4cb25..6c1c5e4 100644
--- a/src/preprocessors/spp_frag3.c
+++ b/src/preprocessors/spp_frag3.c
@@ -505,8 +505,8 @@ static void PrintFragKey(FRAGKEY *fkey)
 
     if(fkey)
     {
-        LogMessage("   sip: %s\n", FragIPToStr(fkey->sip, fkey->ipver));
-        LogMessage("   dip: %s\n", FragIPToStr(fkey->dip, fkey->ipver));
+        LogMessage("    sip: %s\n", FragIPToStr(fkey->sip, fkey->ipver));
+        LogMessage("    dip: %s\n", FragIPToStr(fkey->dip, fkey->ipver));
         LogMessage("     id: %d\n", fkey->id);
         LogMessage("  proto: 0x%X\n", fkey->proto);
 #ifdef MPLS
@@ -4820,6 +4820,11 @@ int fragGetApplicationProtocolId(Packet *p)
             src_port = p->sp;
             dst_port = p->dp;
             break;
+        case IPPROTO_SCTP:
+            ft->ipprotocol = protocolReferenceSCTP;
+            src_port = p->sp;
+            dst_port = p->dp;
+            break;
         case IPPROTO_ICMP:
             ft->ipprotocol = protocolReferenceICMP;
             break;
diff --git a/src/preprocessors/spp_perfmonitor.c b/src/preprocessors/spp_perfmonitor.c
index f8b3c73..00052c9 100644
--- a/src/preprocessors/spp_perfmonitor.c
+++ b/src/preprocessors/spp_perfmonitor.c
@@ -542,6 +542,14 @@ static void ProcessPerfMonitor(Packet *p, void *context)
             type = SFS_TYPE_UDP;
         }
         /*
+        *  SCTP Flow Stats
+        */
+        else if( p->sctph )
+        {
+            UpdateSCTPFlowStatsEx(&sfFlow, p->sp, p->dp, p->pkth->caplen);
+            type = SFS_TYPE_SCTP;
+        }
+        /*
         *  Get stats for ICMP packets
         */
         else if( p->icmph )
@@ -557,6 +565,8 @@ static void ProcessPerfMonitor(Packet *p, void *context)
             type = SFS_TYPE_TCP;
         else if (p->udph)
             type = SFS_TYPE_UDP;
+        else if (p->sctph)
+            type = SFS_TYPE_SCTP;
 
         UpdateFlowIPStats(&sfFlow, GET_SRC_IP(p), GET_DST_IP(p), p->pkth->caplen, type);
     }
diff --git a/src/preprocessors/spp_sfportscan.c b/src/preprocessors/spp_sfportscan.c
index 5861475..4407c14 100644
--- a/src/preprocessors/spp_sfportscan.c
+++ b/src/preprocessors/spp_sfportscan.c
@@ -30,7 +30,7 @@
 **    - User Configuration:  The following is a list of parameters that can
 **      be configured through the user interface:
 **
-**      proto  { tcp udp icmp ip all }
+**      proto  { tcp udp sctp icmp ip all }
 **      scan_type { portscan portsweep decoy_portscan distributed_portscan all }
 **      sense_level { high }    # high, medium, low
 **      watch_ip { }            # list of IPs, CIDR blocks
@@ -447,6 +447,7 @@ static int MakePortscanPkt(PS_PKT *ps_pkt, PS_PROTO *proto, int proto_type,
     {
         case PS_PROTO_TCP:
         case PS_PROTO_UDP:
+        case PS_PROTO_SCTP:
         case PS_PROTO_ICMP:
         case PS_PROTO_IP:
             if(MakeProtoInfo(proto, (u_char *)g_tmp_pkt->data, &ip_size))
@@ -635,6 +636,61 @@ static int PortscanAlertUdp(Packet *p, PS_PROTO *proto, int proto_type)
     return 0;
 }
 
+static int PortscanAlertSctp(Packet *p, PS_PROTO *proto, int proto_type)
+{
+    if(!proto)
+        return -1;
+
+    switch(proto->alerts)
+    {
+        case PS_ALERT_ONE_TO_ONE:
+            GeneratePSSnortEvent(p, GENERATOR_PSNG, PSNG_SCTP_PORTSCAN, 0, 0, 3,
+                    PSNG_SCTP_PORTSCAN_STR);
+            break;
+
+        case PS_ALERT_ONE_TO_ONE_DECOY:
+            GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_DECOY_PORTSCAN, 0, 0, 3,
+                    PSNG_SCTP_DECOY_PORTSCAN_STR);
+            break;
+
+        case PS_ALERT_PORTSWEEP:
+           GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_PORTSWEEP, 0, 0, 3,
+                    PSNG_SCTP_PORTSWEEP_STR);
+            break;
+
+        case PS_ALERT_DISTRIBUTED:
+            GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_DISTRIBUTED_PORTSCAN,
+                    0, 0, 3, PSNG_SCTP_DISTRIBUTED_PORTSCAN_STR);
+            break;
+
+        case PS_ALERT_ONE_TO_ONE_FILTERED:
+            GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_FILTERED_PORTSCAN,0,0,3,
+                    PSNG_SCTP_FILTERED_PORTSCAN_STR);
+            break;
+
+        case PS_ALERT_ONE_TO_ONE_DECOY_FILTERED:
+            GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_FILTERED_DECOY_PORTSCAN,
+                    0,0,3, PSNG_SCTP_FILTERED_DECOY_PORTSCAN_STR);
+            break;
+
+        case PS_ALERT_PORTSWEEP_FILTERED:
+           GeneratePSSnortEvent(p,GENERATOR_PSNG,PSNG_SCTP_PORTSWEEP_FILTERED,0,0,3,
+                    PSNG_SCTP_PORTSWEEP_FILTERED_STR);
+            break;
+
+        case PS_ALERT_DISTRIBUTED_FILTERED:
+            GeneratePSSnortEvent(p,GENERATOR_PSNG,
+                    PSNG_SCTP_FILTERED_DISTRIBUTED_PORTSCAN, 0, 0, 3,
+                    PSNG_SCTP_FILTERED_DISTRIBUTED_PORTSCAN_STR);
+            break;
+
+        default:
+            break;
+    }
+
+    return 0;
+}
+
 static int PortscanAlertIp(Packet *p, PS_PROTO *proto, int proto_type)
 {
     if(!proto)
@@ -750,6 +806,10 @@ static int PortscanAlert(PS_PKT *ps_pkt, PS_PROTO *proto, int proto_type)
                 PortscanAlertIcmp(g_tmp_pkt, proto, proto_type);
                 break;
 
+            case PS_PROTO_SCTP:
+                PortscanAlertSctp(g_tmp_pkt, proto, proto_type);
+                break;
+
             case PS_PROTO_IP:
                 PortscanAlertIp(g_tmp_pkt, proto, proto_type);
                 break;
@@ -848,6 +908,8 @@ static void ParseProtos(int *protos, char **savptr)
             *protos |= PS_PROTO_TCP;
         else if(!strcasecmp(pcTok, "udp"))
             *protos |= PS_PROTO_UDP;
+        else if(!strcasecmp(pcTok, "sctp"))
+            *protos |= PS_PROTO_SCTP;
         else if(!strcasecmp(pcTok, "icmp"))
             *protos |= PS_PROTO_ICMP;
         else if(!strcasecmp(pcTok, "ip"))
@@ -1041,6 +1103,7 @@ static void PrintPortscanConf(int detect_scans, int detect_scan_type,
         SnortSnprintf(buf, STD_BUF + 1, "    Detect Protocols:  ");
         if(detect_scans & PS_PROTO_TCP)  { sfsnprintfappend(buf, STD_BUF, "TCP ");  proto_cnt++; }
         if(detect_scans & PS_PROTO_UDP)  { sfsnprintfappend(buf, STD_BUF, "UDP ");  proto_cnt++; }
+        if(detect_scans & PS_PROTO_SCTP) { sfsnprintfappend(buf, STD_BUF, "SCTP "); proto_cnt++; }
         if(detect_scans & PS_PROTO_ICMP) { sfsnprintfappend(buf, STD_BUF, "ICMP "); proto_cnt++; }
         if(detect_scans & PS_PROTO_IP)   { sfsnprintfappend(buf, STD_BUF, "IP");    proto_cnt++; }
         LogMessage("%s\n", buf);
